Attribute VB_Name = "mdlFileControl"
Option Explicit

'*** API֐` **********************************************
Private Const API_TRUE  As Long = &HFFFFFFFF
Private Const API_FALSE As Long = &H0
'--------------------------------------------------------------
Private Declare Function CopyFile_API Lib "kernel32" Alias "CopyFileA" (ByVal lpExistingFileName As String, ByVal lpNewFileName As String, ByVal bFailIfExists As Long) As Long
Private Declare Function MakeSureDirectoryPathExists Lib "imagehlp.dll" (ByVal DirPath As String) As Long

Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, lpSecurityAttributes As SECURITY_ATTRIBUTES, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function GetFileTime Lib "kernel32" (ByVal hFile As Long, lpCreationTime As FILETIME, lpLastAccessTime As FILETIME, lpLastWriteTime As FILETIME) As Long
Private Declare Function FileTimeToSystemTime Lib "kernel32" (lpFileTime As FILETIME, lpSystemTime As SYSTEMTIME) As Long
Private Declare Function FileTimeToLocalFileTime Lib "kernel32" (lpFileTime As FILETIME, lpLocalFileTime As FILETIME) As Long
Private Declare Function MoveFileEx Lib "kernel32" Alias "MoveFileExA" (ByVal lpExistingFileName As String, ByVal lpNewFileName As String, ByVal dwFlags As Long) As Long
Private Declare Function GetShortPathName Lib "kernel32" Alias "GetShortPathNameA" (ByVal lpszLongPath As String, ByVal lpszShortPath As String, ByVal cchBuffer As Long) As Long
'--------------------------------------------------------------
Private Type SECURITY_ATTRIBUTES
    nLength              As Long
    lpSecurityDescriptor As Long
    bInheritHandle       As Long
End Type
Private Type FILETIME
    dwLowDateTime  As Long
    dwHighDateTime As Long
End Type
Private Type SYSTEMTIME
    wYear         As Integer
    wMonth        As Integer
    wDayOfWeek    As Integer
    wDay          As Integer
    wHour         As Integer
    wMinute       As Integer
    wSecond       As Integer
    wMilliseconds As Integer
End Type
'--------------------------------------------------------------
Private Enum EnumFileMode
    ModeCreated
    ModeLastAccessed
    ModeLastModified
End Enum
'--------------------------------------------------------------
Private Const GENERIC_READ          As Long = &H80000000
Private Const GENERIC_WRITE         As Long = &H40000000
Private Const OPEN_EXISTING         As Long = 3
Private Const INVALID_HANDLE_VALUE  As Long = (-1)
Private Const MOVEFILE_COPY_ALLOWED As Long = &H2
Private Const MAX_PATH              As Long = 260
'**************************************************************

'**
' t@C̍ŏIXV擾
' @param FileName t@C
' @param ŏIXV(yyyy/mm/dd hh:mm:sš`)
Public Function GetDate_APIVer(ByVal FileName As String) As String
    Dim sa As SECURITY_ATTRIBUTES
    Dim hFile As Long
    Dim fTime(2) As FILETIME
    Dim fLocalTime As FILETIME
    Dim sTime As SYSTEMTIME
    Dim d As Date

    If FileName = "" Then Exit Function
    
    sa.nLength = Len(sa)
    hFile = CreateFile(FileName, GENERIC_WRITE, 0&, sa, OPEN_EXISTING, 0&, 0&)
    
    If hFile <> INVALID_HANDLE_VALUE Then
        Call GetFileTime(hFile, fTime(ModeCreated), fTime(ModeLastAccessed), fTime(ModeLastModified))
        Call FileTimeToLocalFileTime(fTime(ModeLastModified), fLocalTime)
        Call FileTimeToSystemTime(fLocalTime, sTime)
        
        With sTime
            GetDate_APIVer = CStr(.wYear) & "/" & Right$("00" & CStr(.wMonth), 2) & "/" & Right$("00" & CStr(.wDay), 2) _
                    & " " _
                    & Right$("00" & CStr(.wHour), 2) & ":" & Right$("00" & CStr(.wMinute), 2) & ":" & Right$("00" & CStr(.wSecond), 2)
        End With
        
        Call CloseHandle(hFile)
    Else
        GetDate_APIVer = ""
    End If
End Function

'**
' t@CRs[
' @param src Rs[
' @param dsc Rs[
' @return 
Public Function CopyFile(ByVal src As String, ByVal dsc As String) As Boolean
    Dim rtn As Long
    
    rtn = MakeSureDirectoryPathExists(dsc)
    rtn = CopyFile_API(src, dsc, API_FALSE)
    If rtn <> API_FALSE Then
        CopyFile = True
    End If
End Function

'**
' t@C폜
' @param File kt@C
' @return 
Public Function DeleteFile(ByVal File As String) As Boolean
    On Error GoTo ErrorHandler
    
    Call Kill(File)

    DeleteFile = True
Exit Function

ErrorHandler:
    If Err.Number <> 0 Then
        DeleteFile = False
    End If
End Function

